
import pickle
import glob
from os import getcwd, chdir

class Project:
	"""This class represents the Project in a build environment."""

	def __init__(self, sName, directory):
		self.sName = sName
		self.directory = directory
		self.aTargets = []
		self.aStats = []

	def Construct(self,platform=None,debug=None):
		if not platform: platform = self._PlatformFromOS()
		curDir = getcwd()
		print "In directory",self.directory
		chdir( self.directory )

		for target in self.aTargets:
			if debug: print getcwd()
			print "Processing %s..." % target.name
			target.Construct(platform,debug=1)
			self.aStats.append( target.GetStats() )

		self.StatsToHTML("%sStatistics.html" % self.sName, debug)
		chdir( curDir )

	def AddTarget(self, NewTarget):
		self.aTargets.append( NewTarget )

	def StatsToHTML(self,outfile,debug=None):
		f = open(outfile,'w')
		print >>f,"<HTML><HEAD><TITLE>%s Statistics</TITLE></HEAD><BODY><TABLE>" % self.sName
		for i in range(len(self.aTargets)):
			print self.aTargets[i].name, self.aStats[i]
			print >>f, "<TR><TD>%s</TD>" % self.aTargets[i].name
			for stat in self.aStats[i]:
				if stat[1]:
					print >>f, '<TD><a href="%s">%s</a></TD>' % (stat[1],stat[0])
				else:
					print >>f, '<TD>%s</TD>' % stat[0]
			print >>f, "</TR>"
			print >>f, "<TR><TD></TD>"
			for stat in self.aStats[i]:
				if debug: print stat
				print >>f, "<TD>%s</TD>" % stat[2]
			print >>f, "</TR>"
		print >>f, "</TABLE></BODY></HTML>"
	
	def _PlatformFromOS(self):
		import sys
		return sys.platform

#	def MakeConfigurations(self):
#		pickles = glob.glob("%s/*.pickle" % self.directory)
#		self.configurations = []
#		for file in pickles:
#			configurations.append( pickle.load(open(pickleFile)) )

#	def __getstate__(self):
#		odict = self.__dict__
#		del odict['aTargets']
#		del odict['aDocumentation']
#		return odict

	def __str__(self):
		sDescription = "Project %s\n" % (self.sName)

		for target in self.aTargets:
			sDescription = "%s\t%s\n" % (sDescription,
				target.__str__() )
		return sDescription

