from Numeric import array
from math import sqrt

def Thompson(a):
    A = a * array((0.0, 0.0, 0.0))
    B = a * array((0.0, sqrt(1.0 / 2.0), 0.0))
    C = a * array((sqrt(3.0 / 8.0), sqrt(1.0 / 8.0), 0.0))
    D = a * array((sqrt(1.0 / 24.0), sqrt(1.0 / 8.0), -sqrt(1.0 / 3.0)))
    alpha = (B + C + D) / 3.0
    beta = (A + C + D) / 3.0
    gamma = (A + B + D) / 3.0
    delta = (A + B + C) / 3.0
    return (A, B, C, D, alpha, beta, gamma, delta)

def Thompson_LC111(a):
    A = a * array((0.0, 0.0, 0.0))
    B = a * array((sqrt(1.0 / 8.0), -sqrt(1.0 / 24.0), -sqrt(1.0 / 3.0)))
    C = a * array((sqrt(1.0 / 2.0), 0.0, 0.0))
    D = a * array((sqrt(1.0 / 8.0), -sqrt(3.0 / 8.0), 0.0))
    alpha = (B + C + D) / 3.0
    beta = (A + C + D) / 3.0
    gamma = (A + B + D) / 3.0
    delta = (A + B + C) / 3.0
    return (A, B, C, D, alpha, beta, gamma, delta)

def Thompson_110(a):
    A = a * array((0.0, 0.0, 0.0))
    B = a * array((0.0, sqrt(1.0 / 2.0), 0.0))
    C = a * array((1.0 / 2.0, sqrt(1.0 / 8.0), sqrt(1.0 / 8.0)))
    D = a * array((1.0 / 2.0, sqrt(1.0 / 8.0), -sqrt(1.0 / 8.0)))
    alpha = (B + C + D) / 3.0
    beta = (A + C + D) / 3.0
    gamma = (A + B + D) / 3.0
    delta = (A + B + C) / 3.0
    return (A, B, C, D, alpha, beta, gamma, delta)

def Thompson_LC(a):
    A = a * array((0.0, 0.0, 0.0))
    B = a * array((0.0, 0.0, -sqrt(1.0 / 2.0)))
    C = a * array((sqrt(3.0 / 8.0), 0.0, -sqrt(1.0 / 8.0)))
    D = a * array((sqrt(1.0 / 24.0), -sqrt(1.0 / 3.0), -sqrt(1.0 / 8.0)))
    alpha = (B + C + D) / 3.0
    beta = (A + C + D) / 3.0
    gamma = (A + B + D) / 3.0
    delta = (A + B + C) / 3.0
    return (A, B, C, D, alpha, beta, gamma, delta)
