import sys
sys.path.append('../../src/QuasiContinuum/SWIGBuild')
sys.path.append('../../src/QuasiContinuum/PythonScripts')

from Numeric import *
import QC3D
from plot import *
from Delaunay import *

potential = QC3D.QCEMTPotential("Cu")
pot = QC3D.EMTPotential("Cu")
d = potential.GetLengthScale()
a = d * sqrt(2)
rc = d * (sqrt(5) + sqrt(4)) / 2
rc1 = d * (sqrt(2) + sqrt(1)) / 2
e = 0.01
lat = a * 0.5 * array([[e, 1, 1], [1, 0, 1], [1 + e, 1, 0]])
lattice = QC3D.GeneralLattice()
lattice.SetLatticeVectors(lat)
N = 4
lattice2 = QC3D.GeneralLattice()
lattice2.SetLatticeVectors(N * lat)

L = (N + 0.5) * a
atoms = QC3D.QCListOfAtoms()
QC3D.RectangularClusterInitializer([L, L, L], lattice).Create(atoms)
nAtomic = atoms.GetNumber()

L2 = (4.5 * N + 1) * a
tmp = QC3D.QCListOfAtoms()
QC3D.RectangularClusterInitializer([L2, L2, L2], lattice2).Create(tmp)
QC3D.OverlapPruner(0.1, atoms.GetCartesianPositionsPtr()).Transform(tmp)
atoms.Merge(tmp)


atoms.DecorateWithSlaves(array([]), nAtomic, rc, lattice)
e0 = potential.CalculateEnergy(atoms) 
print "E0: ", e0, e0 + 26.1114139725
