#!/usr/bin/env python

from Numeric import *
import QC3D

potential = QC3D.QCEMTPotential("Cu")
d = potential.GetLengthScale()
a = d * sqrt(2)
rc = d * (sqrt(4) + sqrt(3)) / 2
rc1 = d * (sqrt(1) + sqrt(2)) / 2

reader = QC3D.NetCDFReader("test2.nc")
nonLocals = reader.Get("nonLocals")
nonLocals.thisown = 0
locals = reader.Get("locals")
locals.thisown = 0
bc = reader.Get("bc")
bc.thisown = 0
masters = QC3D.QCListOfAtoms(nonLocals, locals)
masters.SetBoundaryConditions(bc)
nonLocals.SetBoundaryConditions(bc)

nl = QC3D.CellNeighborList(rc, 0.05 * rc)
# nl = QC3D.SimpleNeighborLocator(rc)
masters.SetNeighborLocator(nl)

meshData = QC3D.NetCDFReader("mesh2.nc").Get("meshData")

potential.SetMeshData(meshData)


e0 = potential.CalculateEnergy(masters) 
print e0
