// DMLastHeader.h
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/


/*! \file DMLastHeader.h
	\brief This should be the last header file included after user header files.

	This header file maps new() to a debug version of new().  There isn't
	an automatic way to replace the library on Win32.
	*/

#ifdef _MSC_VER

#ifdef _DEBUG
// This macro maps new to the version in crtdbg.h, a standard windows
// debug header file.
// The confusion in these definitions is caused by our use
// of new (std::nothrow).  We can match only one of the two possible
// uses of new a) new() or b) new(std::nothrow) so I chose to match
// the more portable nothrow version.
//#define new(s) ::operator new(s, _NORMAL_BLOCK, __FILE__, __LINE__)
//#define new(s) ::operator new(_NORMAL_BLOCK, __FILE__, __LINE__)
#define new(s) new( _NORMAL_BLOCK, __FILE__, __LINE__)
//#define new new( _NORMAL_BLOCK, __FILE__, __LINE__)

#endif //_DEBUG

#endif
