// IEEEFloatingPoing.h
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#ifndef _IEEEFLOATINGPOINT_H_
#define _IEEEFLOATINGPOINT_H_

/**
 * \file IEEEFloatingPoint.h
 *
 * There is an ANSI/IEEE 754 Floating Point Standard which specifies
 * ways to get information on machine precision and a bunch of other
 * numerics devices.  Until we start using it heavily, we can make
 * sure our calls to related functions match the standard and provide
 * machine-dependent implementations here.
 * \author Drew Dolgert
 * \date 12 Feb 2000
 */

#ifdef _MSC_VER

#include "float.h"
/*! On Windows, finite is defined in _finite.  The leading
	underscore indicates this is known to be a machine-dependent
	function and we should wrap it in a standard version, so don't
	call _finite from the body of the code.
	*/
int finite(double val);

#else // _MSC_VER

#include <math.h>

#endif

#endif // _IEEEFLOATINGPOINT_H_
