
//     Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
//     Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

//     This library is free software; you can redistribute it and/or modify it
//     under the terms of the GNU Lesser General Public License as published by the
//     Free Software Foundation; either version 2.1 of the License, or (at your
//     option) any later version.

//     This library is distributed in the hope that it will be useful, but WITHOUT
//     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
//     FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
//     for more details.

//     You should have received a copy of the GNU Lesser General Public License
//     along with this library; if not, write to the Free Software Foundation,
//     Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
//     http://www.gnu.org/licenses/lgpl.html

//     Author Contact Information:
//     Jim Sethna      
//     sethna@lassp.cornell.edu  
//     117 Clark Hall
//     Cornell University
//     Ithaca, NY 14850


### COMMUNICATION ###

%{
#include "Parallel/MPIProtocol.h"
#include "Parallel/MPISendBuffer.h"
#include "Parallel/MPIRecvBuffer.h"
%}

class MPISendBuffer: public DMWriter
{
public:
	%extend
	{
		void PutNumPyArrayInt(PyObject *obj)
		{
			ASSERT(PyArray_Check(obj)) ;
			PyArrayObject *o = (PyArrayObject *)(obj);
			std::vector<int> vect(o->dimensions, o->dimensions+o->nd);
			const int *data = (const int*)(o->data);
			self->PutIntArray(data, vect, "");
		}
	}
};

class MPIRecvBuffer: public DMReader 
{
public:
	%extend
	{
		PyObject* GetNumPyArrayInt()
		{
			std::vector<int> vect;
			int *tmp = self->GetIntArray(vect, "");
			int totSize = 1;
			for(int c=0; c<vect.size(); ++c) totSize *= vect[c];
			PyObject *o = PyArray_FromDims(vect.size(), &vect[0], 'i');
			memcpy(((PyArrayObject *)o)->data, tmp, sizeof(int)*totSize);
			delete [] tmp;
			return o;
		}
	}
}; 

class MPIProtocol : public DMProtocol
{
public:
	MPIProtocol();
};

