/*
 * SimQA: Copyright (C) Jakob Schiotz 1996, 1997
 *
 * IBM POWER2 optimized vector library:
 * Vectorized r = a * b + c
 */

#include "vectools.h"

/* r[] = a[] + b */
void vec_add_scal(double *res, const double *a, double b, int n)
{
#ifdef AIX
#pragma disjoint (*res, *a, b)
#endif
    
    int i, limit;
    double a0, a1, a2, a3, a4, a5, a6, a7;

    limit = n-7;
    for (i = 0; i < limit; i+=8)
    {
	a0 = a[i];
	a1 = a[i+1];
	a2 = a[i+2];
	a3 = a[i+3];
	a4 = a[i+4];
	a5 = a[i+5];
	a6 = a[i+6];
	a7 = a[i+7];
	res[i] = a0 + b;
	res[i+1] = a1 + b;
	res[i+2] = a2 + b;
	res[i+3] = a3 + b;
	res[i+4] = a4 + b;
	res[i+5] = a5 + b;
	res[i+6] = a6 + b;
	res[i+7] = a7 + b;
    }
    for (i = n - n % 8; i < n; i++)
    {
	a0 = a[i];
	res[i] = a0 + b;
    }
}
