/*
 * SimQA: Copyright (C) Jakob Schiotz 1996, 1997
 *
 * IBM POWER2 optimized vector library:
 * r = r * a + b * c */

#include "vectools.h"

/* r[] = r[] * a[] + b * c[] */
void vec_eq_self_mul_addscal_mul(double *res, const double *a, double b, const double *c,
				 int n)
{
#ifdef AIX
#pragma disjoint (*res, *a, b, *c)
#endif
    
    int i, limit;
    double a0, a1, a2, a3;
    double c0, c1, c2, c3;
    double s0, s1, s2, s3;

    limit=n-3;
    
    for (i = 0; i < limit; i+=4)
    {
	s0 = res[i];
	s1 = res[i+1];
	s2 = res[i+2];
	s3 = res[i+3];
	a0 = a[i];
	a1 = a[i+1];
	a2 = a[i+2];
	a3 = a[i+3];
	c0 = c[i];
	c1 = c[i+1];
	c2 = c[i+2];
	c3 = c[i+3];
	res[i] = s0 * a0 + b * c0;
	res[i+1] = s1 * a1 + b * c1;
	res[i+2] = s2 * a2 + b * c2;
	res[i+3] = s3 * a3 + b * c3;
    }
    for (i = n - n % 4; i < n; i++)
    {
	s0 = res[i];
	a0 = a[i];
	c0 = c[i];
	res[i] = s0 * a0 + b * c0;
    }
}
