#include "DiscreteAvalanche.h"
#include "CheckpointCalculator.h"
#include "DMException.h"
#include "DMLastHeader.h"


void CheckpointCalculator::SetFrequency( int seconds )
{
	ASSERT( seconds > 0 );
	if (seconds <= 0 ) throw DMException( "CheckpointCalculator",
		"SetFrequency","The frequency should be greater than zero." );

	m_checkpointFrequency = seconds;
}

int CheckpointCalculator::GetNextCheckpoint( int currentTime, int endTime )
{
	int regularCheck =
		((currentTime/m_checkpointFrequency)+1)*m_checkpointFrequency;

	if (endTime>0) {
		// There is some thought that the last check should be
		// before the exact end time.
		int lastCheck = endTime;
		int twoHourCheck = endTime-120*60;

		if ( currentTime >= lastCheck ) {
			return -1;
		} else if ( ( currentTime < twoHourCheck ) &&
			        ( twoHourCheck < regularCheck ) ) {
			return twoHourCheck;
		} else if ( ( currentTime < lastCheck ) &&
					( lastCheck < regularCheck ) ) {
			return lastCheck;
		} // else regularCheck is the right choice.
	}

	return regularCheck;
}
