#ifndef _EXCEPTION_HANDLER_H_
#define _EXCEPTION_HANDLER_H_

#include "DMFirstHeader.h"
#include <windows.h>
#include "DiscreteAvalanche.h"

//! Sets global error handling code before program start.
/*! I'm still confused about how these things interact.
	There is a global error mode.  Then you can set the 
	CrtWarn locations.  And BugslayerUtil will call the
	SetExceptionHandler for you to catch unhandled SEH
	exceptions.

	\author ajd27
	\date 2 Sept 2000
	*/
class ExceptionHandler
{
	UINT uiErrorMode; //!< Stores error mode in order to restore it.
public:
	//! Constructor which sets the code.
	ExceptionHandler();
	//! Destructor to remove settings.
	~ExceptionHandler();
};

// This is how you make sure that anyone who includes this 
// header file also gets the static exception handler linked.
// I'm not proud of this, but Microsoft made me do it.
// I found this value by doing dumpbin /symbols ExceptionHandler.obj
// where dumpbin is in Visual Studio.
#pragma comment(linker, "/include:?_exceptionHandler@@3PAVExceptionHandler@@A")

#endif //_EXCEPTION_HANDLER_H_
