#ifndef _FALIED_VERIFY_H_
#define _FAILED_VERIFY_H_

#include "DMFirstHeader.h"
#include <string>
#include "DiscreteAvalanche.h"
#include "DMException.h"

//! This exception signals that a class has not been properly initialized.
/*! Some classes have a Verify() method which you can call to determine
	whether you have initialized it properly by calling all the right Set() 
	functions.  If something is amiss in there, this exception is thrown.
	*/
class FailedVerify : public DMException
{
public:
	//! Constructor
	/*! It is assumed that the method which failed is
		called "Verify."

		@param sClass Class in which exception occurred.
		@param sReason Why the verification failed.
		*/
	FailedVerify( const std::string& sClass, const std::string& sReason );
};

#endif // _FAILED_VERIFY_H_
