#ifndef _ORDERBYFIELDS_H_
#define _ORDERBYFIELDS_H_
#include "DMFirstHeader.h"
#include "DiscreteAvalanche.h"

//! Helper class for STL sorts of spins by random field.
/** The OrderByFields structure defines the sort order for the STL sort routine.
 * It defines an order such that the spins are sorted from greatest random
 * field to smallest random field.
 */
struct OrderByFields
{
	const double *randomField;
	bool operator () (int a, int b) { return (randomField[a]>randomField[b]); }
};


#endif //_ORDERBYFIELDS_H_