#include "DMFirstHeader.h"
#include <iostream>
#include "SimpleTracer.h"
#include "DMException.h"
#include "DMLastHeader.h"

SimpleTracer::SimpleTracer()
{
	uiTraceFrequency = 300; // default time in seconds.
}

/*! The trace frequency defaults to five minutes if you
	don't call this.
	*/
void SimpleTracer::SetTraceFrequency( int uiSeconds )
{
	ASSERT( uiSeconds > 0 );
	if ( uiSeconds <= 0 ) throw DMException("SimpleTracer",
		"SetTraceFrequency","The frequency should be greater than zero.");

	this->uiTraceFrequency = uiSeconds;
}

int SimpleTracer::GetNextTrace( int uiCurrentTime,
	int uiEndTime )
{
	return ((uiCurrentTime/uiTraceFrequency)+1)*uiTraceFrequency;
}

void SimpleTracer::Trace( int uiCurrentTime )
{
	std::cout << "Still Running at " << uiCurrentTime/60.0
		<< " minutes." << std::endl;
}
