#ifndef _SPININDEX_H_
#define _SPININDEX_H_

/*! \typedef SpinIndex
	\brief An integer type for counting spins.
	
	This type isn't always an integer because it could
	easily be greater than the size of an integer.
	If you have more spins than an int can handle, change
	this to a 64 bit int.
	*/
typedef int SpinIndex;

/*! \typedef SpinCoord
	\brief Measures length of a side of spins.
	*/
typedef int SpinCoord;

#endif //_SPININDEX_H_