#ifndef _TRACER_H_
#define _TRACER_H_

#include "DMFirstHeader.h"
#include "DiscreteAvalanche.h"

//! Interface to class which can print trace statements.
/*! Time is measured in seconds as far as this is concerned.
	*/
class Tracer
{
public:
	//! Returns the next time beyond now to trace.
	/*!
		\param uiCurrentTime Time since time=0.
		\param uiEndTime May be zero if there is no end time
		\return Time of next trace beyond current time.
		*/
	virtual int GetNextTrace( int uiCurrentTime,
		int uiEndTime ) = 0;
	virtual void SetTraceFrequency( int seconds ) = 0;
	//! Does the tracing.
	/*!
		@param uiCurrentTime  The current time in seconds
		since the start of the simulation.
		*/
	virtual void Trace( int uiCurrenTime ) = 0;
};

#endif //_TRACER_H_
