// RandomInitializer.h: interface for the RandomInitializer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef RANDOMINITIALIZER_H
#define RANDOMINITIALIZER_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

#include "KMCInitializer.h"
#include "Rand.h"	// Added by ClassView

class RandomInitializer : public KMCInitializer  
{
public:
	//! RandomInitializer: Sets up random initial conditions for lattice
	/**
	  * RandomInitializer: Sets up random initial conditions for lattice
	  * For right now, it fills in lattice with random +-1.
	  * We need to think about this when we make the KMCLattice into a template:
	  *   how do we make order parameter values at random?
	  *
	  * \ingroup KineticMonteCarlo
	  */

	RandomInitializer();
	virtual ~RandomInitializer();

	void Initialize(KMCLattice *lattice);
private:
	Rand rand;
};

#endif // !defined(RANDOMINITIALIZER_H)
