// EmptyInitializer.h: interface for the EmptyInitializer class.
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#ifndef EMPTYINITIALIZER_H
#define EMPTYINITIALIZER_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif // SWIG

// Implementation of the EmptyInitializer factory method
// Initializes no atoms.  Useful for parallel scripts
// so that when wrapped with ParallelAtomsInitializer, 
// all processors automatically have same ListOfAtoms
// tree structure

#include "AtomsInitializer.h"

class EmptyInitializer : public AtomsInitializer
{
public:
  EmptyInitializer();
  ~EmptyInitializer();
  void Create(ListOfAtoms *atoms);
  const double *GetCenter() const {return clusterCenter;}
  double GetMaxSize() const {return 1.0;}

private:
  double clusterCenter[DIMENSION];

};

#endif // !defined(EMPTYINITIALIZER_H)
