
//     Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
//     Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

//     This library is free software; you can redistribute it and/or modify it
//     under the terms of the GNU Lesser General Public License as published by the
//     Free Software Foundation; either version 2.1 of the License, or (at your
//     option) any later version.

//     This library is distributed in the hope that it will be useful, but WITHOUT
//     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
//     FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
//     for more details.

//     You should have received a copy of the GNU Lesser General Public License
//     along with this library; if not, write to the Free Software Foundation,
//     Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
//     http://www.gnu.org/licenses/lgpl.html

//     Author Contact Information:
//     Jim Sethna      
//     sethna@lassp.cornell.edu  
//     117 Clark Hall
//     Cornell University
//     Ithaca, NY 14850


%{
#include "Shape.h"
#ifdef __GNUC__
#include <strstream>
#else
#include <sstream>
#endif // __GNUC__
%}

class Shape
{
public:
	Shape(int i=0);
	int GetNSubShapes() const;
	Shape GetSubShape(int i) const ;
	int NumberOfLeaves() const ;
%extend
{
public:
	PyObject * __str__()
	{  // uses stringstream. If your platform doesn't support it, just remove this function.
%#ifdef __GNUC__
		std::strstream o;
		o << *self << (char) 0;
		return PyString_FromString(o.str());
%#else
		std::stringstream o;
		o << *self;
		return PyString_FromString(o.str().c_str());
%#endif // __GNUC__
	}
}

};
