
//     Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
//     Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

//     This library is free software; you can redistribute it and/or modify it
//     under the terms of the GNU Lesser General Public License as published by the
//     Free Software Foundation; either version 2.1 of the License, or (at your
//     option) any later version.

//     This library is distributed in the hope that it will be useful, but WITHOUT
//     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
//     FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
//     for more details.

//     You should have received a copy of the GNU Lesser General Public License
//     along with this library; if not, write to the Free Software Foundation,
//     Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
//     http://www.gnu.org/licenses/lgpl.html

//     Author Contact Information:
//     Jim Sethna      
//     sethna@lassp.cornell.edu  
//     117 Clark Hall
//     Cornell University
//     Ithaca, NY 14850


#if DIMENSION == 3
%module MD3D
#else
%module MD2D
#endif

%include DMSystem.i

%{
#include <vector>
#include <string>
%}

%include stringTypeMap.i


/// Convert type[DIMENSION] to python lists or numpy arrays
%include "DimensionArrayTypeMap.i"


/// base classes:


%include cpointer.i

/// BRAVAIS LATTICES ///
%include BravaisLatticeWithBasis.i

/// SHAPE ///
%include Shape.i

/// MATRIX AND VECTORS ///
%include DMArray.i


/// ATOMS INITIALIZERS ///
%include "AtomsInitializers.i"

/// LISTS OF ATOMS ///
%include "ListOfAtoms.i"

/// POTENTIALS ///
%include "Potentials.i"

/// NEIGHBOR LOCATORS ///
%include "NeighborLocators.i"

/// ATOMS MOVERS ///
%include "AtomsMovers.i"

/// BOUNDARY CONDITIONS ///
%include "BoundaryConditions.i"

/// TRANSFOMERS ///
%include "Transformers.i"

/// LOAOBSERVERS ///
%include "Observers.i"

/// CONSTRAINTS ///
%include "../MDFiles/Constraints/Constraints.i"  # there's already a file "constraints.i" in SWIG's includes.

/// UNIXINTERFACE ///
#ifndef _WINDOWS
%include "UnixInterface.i"
#endif // WINDOWS

/// PARALLEL ///
#ifdef DMPARALLEL
%include "ParallelMD.i"
#endif

