// MDDoc.h : interface of the CMDDoc class
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#if !defined(AFX_MDDOC_H__E82102C4_3365_4952_A198_E137242E83E8__INCLUDED_)
#define AFX_MDDOC_H__E82102C4_3365_4952_A198_E137242E83E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MDSimulation.h"	// Added by ClassView

// All of these are referenced in the interface only as pointers.
// We declare them here without specification in order to minimize
// the tendency to rebuild the simulation.
class DialogBuilder;
//class vtkPropSource;
class MDComponentSelector;
class ChangeParameterMenu;
class TransformerMenu;
class MDThread;
class Thread;
/*! \ingroup windows */

class CMDDoc : public CDocument
{
protected: // create from serialization only
	CMDDoc();
	DECLARE_DYNCREATE(CMDDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMDDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

	// Digital Material: The wizard won't let us add these?
	virtual void OnMenuSelect(UINT nID);
	virtual void OnUpdateComponentUI (CCmdUI* pCmdUI);

// Implementation
public:
	MDSimulation sim;
	Thread *const GetSimThread();
	MDComponentSelector *const GetComponentSelector();
	ChangeParameterMenu *const GetChangeParameterMenu();
	TransformerMenu *const GetTransformerMenu();
//	vtkPropSource* GetVTKPropSource(void);

	virtual ~CMDDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
private:
	MDThread *simBody;
	Thread *simThread;
//	vtkPropSource *vtkCoordSource;
	MDComponentSelector *componentSelector;
	ChangeParameterMenu *changeParameterMenu;
	TransformerMenu *transformerMenu;

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMDDoc)
	afx_msg void OnControlPauseresume();
	//}}AFX_MSG
//	afx_msg LRESULT OnUpdateViews( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MDDOC_H__E82102C4_3365_4952_A198_E137242E83E8__INCLUDED_)
