#C:\\Documents and Settings\\myers.CTC_ITH\\Desktop\\tmp\\DigitalMaterial.PX\\src\\MD\\WinSWIGBuild

import reflection, types, string, Tkinter

def hasSubstring(str, substr):
    if string.find(str, substr) == -1:
        return 0
    else:
        return 1

def isAGetMethod(method):
    return method[0:3]=='Get'

def FindGettableName(method):
    if isAGetMethod(method): 
        return method[3:]
    else:
        raise ValueError, "Not a Get method"

def isASetMethod(method):
    return method[0:3]=='Set'

def hasASetMethod(object, gettable):
    return hasattr(object, 'Set'+gettable)

def stripFirstThree(str):
    return str[3:]

def findAllMethodsOfObject(object):
    return reflection.inspectObject(object)['allmethods']

def findAllGetMethodsOfObject(object):
    allmethods = findAllMethodsOfObject(object).copy()
    for name, function in allmethods.items():
        if not isAGetMethod(name): del allmethods[name]
    return allmethods
    
def findGettableObjectMembers(object):
    allgetmethods = findAllGetMethodsOfObject(object)
    allgetvalues = {}
    for name, function in allgetmethods.items():
        try:
            val = apply(function, (object,))
            allgetvalues[stripFirstThree(name)] = val
        except:
            pass
    return allgetvalues

def is_int(object):
    return type(object)==types.IntType

def is_float(object):
    return type(object)==types.FloatType

def is_string(object):
    return type(object)==types.StringType

def is_DMArray(object):
    if hasattr(object, 'this'):
        return hasSubstring(object.this, 'DMArray')
    else:
        return 0

import VariableConfiguration
VC = VariableConfiguration

def BuildGettableVariableTable(object, object_name):
    allgetvalues = findGettableObjectMembers(object)
    t = VC.VariableTable()
    for name, value in allgetvalues.items():
        typestr = VC.TypeToTypename(type(value))
        t[name] = VC.Variable(name, value, VC.Signature(typestr))
    return t


if __name__ == '__main__':

    class Dummy:
        pass

    class BigDummy:
        def __init__(self):
            self._IntVar = 12
            self._FloatVar = 3.14159
            self._ComplexVar = 3.2+4.5j
            self._StringVar = 'dog'
            self._InstanceVar = Dummy()
    
        def GetFloatVar(self):
            return self._FloatVar

        def GetIntVar(self):
            return self._IntVar

        def GetComplexVar(self):
            return self._ComplexVar

        def GetStringVar(self):
            return self._StringVar

        def GetInstanceVar(self):
            return self._InstanceVar

        def SetFloatVar(self, value):
            self._FloatVar = value
 
        def SetIntVar(self, value):
            self._IntVar = value


    bd = BigDummy()
    table = BuildGettableVariableTable(bd, 'bd')
    gui = VC.TkVariableTable(table)
