import VTK, sys

if len(sys.argv) < 2:
    raise IOError, "must specify input file"
else:
    filename = sys.argv[1]

ren = VTK.vtkRenderer()
renWin = VTK.vtkRenderWindow()
renWin.AddRenderer(ren)
renWin.SetSize(500,500)

iren = VTK.vtkRenderWindowInteractor()
iren.SetRenderWindow(renWin)

reader = VTK.vtkPolyDataReader()
reader.SetFileName(filename)
data   = reader.GetOutput()
data.Update()

# scalars = VTK.vtkScalars()
# npolys = data.GetNumberOfPolys()
# scalars.SetNumberOfScalars(npolys)
# for n in range(npolys):
#     scalars.InsertScalar(n, float(n))
# data.GetCellData().SetScalars(scalars)

mapper = VTK.vtkDataSetMapper()
mapper.SetInput(data)
mapper.SetScalarRange(0, 256)
actor  = VTK.vtkLODActor()
actor.SetNumberOfCloudPoints(1000)
actor.SetMapper(mapper)
ren.SetBackground(1.,1.,1.)
ren.AddActor(actor)

#ren.GetActiveCamera().Azimuth(30)
#ren.GetActiveCamera().Elevation(20)
#ren.GetActiveCamera().Dolly(1.0)
#ren.ResetCameraClippingRange()
renWin.Render()

iren.Initialize()
iren.Start()



