import VTK, sys

def DisplayGBPolyData(gbpolydata, lookupTable=None):

    ren = VTK.vtkRenderer()
    renWin = VTK.vtkRenderWindow()
    renWin.AddRenderer(ren)
    renWin.SetSize(500,500)

    iren = VTK.vtkRenderWindowInteractor()
    iren.SetRenderWindow(renWin)

    gbpolydata.Update()

    mapper = VTK.vtkDataSetMapper()
    mapper.SetInput(gbpolydata)
    if lookupTable is not None: mapper.SetLookupTable(lookupTable)
    actor  = VTK.vtkActor()
    actor.SetMapper(mapper)
    ren.SetBackground(0.,0.,0.)
    ren.AddActor(actor)

    ren.GetActiveCamera().Azimuth(30)
    ren.GetActiveCamera().Elevation(20)
    ren.GetActiveCamera().Dolly(1.0)
    ren.ResetCameraClippingRange()
    renWin.Render()

    iren.Initialize()
    iren.Start()



