#!/usr/bin/python

from pyvtk import *
import string
from math import fabs

r = Renderer(1)

math = vtkMath()
#numberOfInputPoints=30

def saveImage():
    import tempfile
    print ren.renwin
    ren.renwin.SetFileName('tmpf')
    ren.renwin.SaveImageAsPPM()
    
#r.iren.SetUserMethod(saveImage)

def readPoints(file):
    f = open(file, 'r')
    inputPoints = vtkPoints()
    n = 0
    line = string.split(f.readline())
    while len(line) != 0:
	p = map(string.atof, line)
	if fabs(p[0]) < 17.0 and fabs(p[1]) < 17.0 and fabs(p[2]) < 17.0:
	    inputPoints.InsertPoint(n, p[0], p[1], p[2])
	line = string.split(f.readline())
	n = n+1
    return inputPoints
	
inputPoints = readPoints('triplejct.dat')

inputData = vtkPolyData()
inputData.SetPoints(inputPoints)

balls = vtkSphereSource()
balls.SetRadius(1.5)
balls.SetPhiResolution(15)
balls.SetThetaResolution(15)

glyphPoints = vtkGlyph3D()
glyphPoints.SetInput(inputData)
glyphPoints.SetSource(balls.GetOutput())

glyphMapper = vtkPolyDataMapper()
glyphMapper.SetInput(glyphPoints.GetOutput())

glyph = vtkLODActor()
glyph.SetMapper(glyphMapper)
glyph.GetProperty().SetDiffuseColor(0.9, 0.2, 0.2)
glyph.GetProperty().SetSpecular(.3)
glyph.GetProperty().SetSpecularPower(30)

r.AddActor(glyph)
r.Initialize()

r.GetActiveCamera().Dolly(1.2)
r.SetSize(500,500)

r.show()
