#ifndef ADVECTIONEQUATION_H
#define ADVECTIONEQUATION_H

#ifdef _DEBUG
#include <assert.h>
#endif

#include "DigitalMaterial.h"
#include "Field.h"
#include "RightHandSide.h"
#include "OperatorOperand.h"
#include "UnaryOperators.h"
#include "BinaryOperators.h"

//#include "Introspective.h"
//#include "Clonable.h"


class AdvectionEquation : public RightHandSide //, public Introspective, public Cloneable
{
	protected:
		Point velocity;
		DirDerivative grad_x_;
		MultiplyReal Times;
		MakeEqual Equal;
	public:
		AdvectionEquation(void);
		AdvectionEquation(const AdvectionEquation &cop);
		virtual ~AdvectionEquation(void);
		virtual bool RHS(const FieldCollection &input, FieldCollection &output);
		virtual Point GetVelocity(void) const { return(velocity); }
		virtual bool SetVelocity(const Point & v) { velocity=v; return(true); }
};


#endif
