#ifndef SIMPLEPERIODICBC_H
#define SIMPLEPERIODICBC_H

#ifdef _DEBUG
#include <assert.h>
#endif //_DEBUG

#include "DigitalMaterial.h"
#include "BoundaryCondition.h"

//#include "Introspective.h"
//#include "Clonable.h"


class SimplePeriodicBC : public virtual BoundaryCondition 
			//, virtual Introspective, public Cloneable // not yet!
{
 private:
		Point physical_size;
		Point helicity;
 public:
		SimplePeriodicBC();
#ifndef SWIG
		SimplePeriodicBC(const SimplePeriodicBC & spbc);
		SimplePeriodicBC(const Point & box);
#endif //SWIG
		virtual ~SimplePeriodicBC() {} ;
		virtual BoundaryCondition * AllocCopy(void) const;

		virtual Real Volume() const { return(physical_size.Volume()); }
		//virtual bool IsNumberOfFieldsOK(int number) const { return(true); }
		virtual bool FoldBackIntoSupport(Point & point) const;
		virtual bool SetPhysicalSize(const Point &x);
		virtual Real GetPhysicalSize(int d) const { return(physical_size(d)); }
		virtual bool SetHelicity(const Point &x) { helicity=x; return(true); }
		virtual Real GetHelicity(int d) const { return(helicity(d)); }
#ifndef SWIG
		virtual Point GetPhysicalSize() const { return(physical_size); }
		virtual Point GetHelicity() const { return(helicity); }
#endif //SWIG
};


#endif
