import sys
sys.path.append('/afs/msc.cornell.edu/home/jsethna/myers/pub/lib/python1.5/site-packages/VTK')
sys.path.append('/usr/local/pub/dm/lib')
sys.path.append('/usr/local/pub/lib/python1.5/NumPy')

#from libVTKCommonPython import *
#from libVTKGraphicsPython import *
from VTK import *
import string
from math import *
from Numeric import *

class PlotAtoms:

    def __init__(self, data, pointFilter=None):
        self.pointFilter = pointFilter
        if isinstance(data, types.StringType): self.readPoints(self.filename)
        else: self.dataToVTKPoints(data)
        self.images = []

    def saveImage(self):
        import tempfile
        image_filename = tempfile.mktemp('.ppm')
        self.renWin.SetFileName(image_filename)
        self.renWin.SaveImageAsPPM()
        print "Saving image to %s" % image_filename
        self.images.append(image_filename)
        return

    def saveTIFFImage(self, filename = None):
        w2if = vtkWindowToImageFilter()
        w2if.SetInput(self.renWin)
        writer = vtkTIFFWriter()
        writer.SetInput(w2if.GetOutput())
        if (filename):
            writer.SetFileName(filename)
        else:
            writer.SetFileName("temp.tiff")
        writer.Write()
        return

    def dataToVTKPoints(self,data):
        self.inputPoints = vtkPoints()
        for i in range(len(data)):
            if self.pointFilter is None:
                o = data[i][0]
                self.inputPoints.InsertPoint(i, data[i][0], data[i][1], 0.)
            elif self.pointFilter(i,data[i]):
                self.inputPoints.InsertPoint(i, data[i][0], data[i][1], 0.)

    def readPoints(self, filename):
        f = open(filename, 'r')
        self.inputPoints = vtkPoints()
        n = 0
        line = string.split(f.readline())
        while len(line) != 0:
            p = map(string.atof, line)
            if self.pointFilter is None:
                self.inputPoints.InsertPoint(n, p[0], p[1])
                n = n+1
            elif self.pointFilter(n,p):
                self.inputPoints.InsertPoint(n, p[0], p[1])
                n = n+1
            line = string.split(f.readline())
	
    def display(self,
                radius=1.5, phiResolution=10, thetaResolution=10,
                LevelOfDetail=0):

        inputData = vtkPolyData()
        inputData.SetPoints(self.inputPoints)

        balls = vtkSphereSource()
        balls.SetRadius(radius)
        balls.SetPhiResolution(phiResolution)
        balls.SetThetaResolution(thetaResolution)

        glyphPoints = vtkGlyph3D()
        glyphPoints.SetInput(inputData)
        glyphPoints.SetSource(balls.GetOutput())
        glyphMapper = vtkPolyDataMapper()
        glyphMapper.SetInput(glyphPoints.GetOutput())

        if LevelOfDetail:
            glyph = vtkLODActor()
        else:
            glyph = vtkActor()
        glyph.SetMapper(glyphMapper)
        glyph.GetProperty().SetDiffuseColor(0.9, 0.2, 0.2)
        glyph.GetProperty().SetSpecular(0.3)
        glyph.GetProperty().SetSpecularPower(30)

        self.ren = vtkRenderer()
        self.renWin = vtkRenderWindow()
        self.renWin.AddRenderer(self.ren)
        self.renWin.SetSize(500,500)
        self.ren.AddActor(glyph)

        self.iren = vtkRenderWindowInteractor()
        self.iren.SetRenderWindow(self.renWin)
        self.iren.SetUserMethod(self.saveImage)

        self.iren.Initialize()
        self.iren.Start()


def distanceCutoff(n, p):
    import math
    dist = math.sqrt(p[0]*p[0] + p[1]*p[1] + p[2]*p[2])
    val = dist < 40.
    return val

def identity(n, p):
    return 1

#def test():
#    plot = PlotAtoms('triplejct.dat', pointFilter=distanceCutoff)
#    plot.display(LevelOfDetail=1)

#if __name__ == '__main__':
#    test()
    
