#include "NeighborLocator.h"
#include "MeshData.h"
#include "QCListOfAtoms.h"

class QCNeighborList2 : public NeighborLocator
{
public:
    QCNeighborList2(NeighborLocator* nl0, int nNonLocal) :
        NeighborLocator(0.0), nl(nl0), nNonLocal(nNonLocal)
        {
        }
//    ~NeighborLocator();
    bool HalfNeighbors(int atomNumber,
                       int * neighbors, 
                       int& numNeighbors,
                       double (*displacements)[DIMENSION],
                       double* displacementsSquared,
                       int& spacesLeftInArrays)
        {assert(false); return false;}
    bool Neighbors(int atomNumber,
                   int * neighbors, 
                   int& numNeighbors,
                   double (*displacements)[DIMENSION],
                   double* displacementsSquared,
                   int& spacesLeftInArrays)
        {
            if (atomNumber < nNonLocal)
                return Neighbors(atomNumber, neighbors, numNeighbors,
                                 displacements, displacementsSquared,
                                 spacesLeftInArrays);
            numNeighbors = 0;
            return true;
        }
    bool Neighbors(const double *center,
                   int* neighbors, 
                   int& numNeighbors,
                   double (*displacements)[DIMENSION],
                   double* displacementsSquared,
                   int& spacesLeftInArrays, double cutoff=-1.)
        {assert(false); return false;}
    void UpdatePosition() {nl->UpdatePosition();}
    NeighborLocator* Copy() const  {assert(false); return 0;}
private:
    NeighborLocator* nl;
    int nNonLocal;
};
