# -*- makefile -*-
# The root directory of the src.  You have to set this so everything
# below can have absolute paths.
DMROOT = /home/data/$(USER)/DigitalMaterial
# Global settings
ARCH = $(shell uname -m)


##################################################################
####                                                          ####
####               Compaq alpha running OSF1                  ####
####                                                          ####
##################################################################

ifeq ($(ARCH),alpha)

# Install directories
# INSTALLPY indicates where 
INSTALLPY = ($HOME)/python/DM
INSTALLSWIG =
# Global options (to add to any local ones)
# OPTS = -O3 -ptr $(DMROOT)/cxx_repository  -D__USE_STD_IOSTREAM -I/usr/local/include -I/usr/local/include/python1.5/Numeric
OPTS = -g -ptr $(DMROOT)/cxx_repository  -D__USE_STD_IOSTREAM -I/usr/local/include -I/usr/local/include/python1.5/Numeric
# Our preferred shell.
SHELL = /usr/local/bin/tcsh
# C compiler
CC = cc
# C++ compiler
CXX = cxx 
# C preprocessor
CPP = cxx -M
# Makes archives
AR = ar
# Fixes archive links for a library
RANLIB = ranlib
# location of doxygen
DOXYGEN = 

# The path to swig. Set SWIG to nothing if you do not want to build the python package.
# SWIG = /usr/local/bin/swig
SWIG = /home/data/schiotz/src/SWIG1.1p5/swig
#SWIGOPT = -shadow -dnone
SWIGOPT = -shadow
# Check for the next variables in swig's Makefile.template
#CCSHARED        = -fpic
CCSHARED        = 
CXXSHARED       = $(CXX) -shared -expect_unresolved "*"
PYTHON_INCLUDE  = -DHAVE_CONFIG_H -I/usr/local/include/python1.5 -I/usr/local/lib/python1.5/config
CPP_DLLIBS      = 
SO              = .so

DMPARALLEL = 0
MPIcc = mpicc
MPICC = mpiCC

ifeq ($(DMPARALLEL),1)
CC = $(MPIcc)
CXX = $(MPICC)
OPTS += -DDMPARALLEL
endif

export DMROOT ARCH OPTS SHELL CC CXX CPP AR RANLIB DOXYGEN SWIG SWIGOPT CCSHARED CXXSHARED PYTHON_INCLUDE CPP_DLLIBS SO DMPARALLEL

endif  # ifeq ($(ARCH),alpha)




##################################################################
####                                                          ####
####                Intel i686 running Linux                  ####
####                                                          ####
##################################################################


ifeq ($(ARCH),i686)

# Install directories
# INSTALLPY indicates where 
INSTALLPY = ($HOME)/python/DM
INSTALLSWIG =
# Global options (to add to any local ones)
# OPTS = -O3 -D__USE_STD_IOSTREAM -I/usr/local/include
OPTS = -g -D__USE_STD_IOSTREAM -I/usr/local/include -I/usr/include/python1.5/Numeric
# Our preferred shell.
SHELL = /bin/tcsh
# C compiler
CC = gcc
# C++ compiler
CXX = g++ 
# C preprocessor
CPP = g++ -E -MM
# Makes archives
AR = ar
# Fixes archive links for a library
RANLIB = ranlib
# location of doxygen
DOXYGEN = doxygen
# Wrapped Application Debugger (if available)
WADPY =
# WADPY = -L/home/data/schiotz/src/WAD0.0-0/Prebuilt/linux -Wl,-rpath,/home/data/schiotz/src/WAD0.0-0/Prebuilt/linux -lwadpy

# The path to swig. Set SWIG to nothing if you do not want to build the python package.
SWIG = swig
SWIGOPT = -shadow -dnone
# Check for the next variables in swig's Makefile.template
CCSHARED        = -fPIC
# CCSHARED        = -fpic
CXXSHARED       = $(CXX) -shared
PYTHON_INCLUDE  = -DHAVE_CONFIG_H -I/usr/include/python1.5 -I/usr/lib/python1.5/config
CPP_DLLIBS      = 
SO              = .so

export DMROOT ARCH OPTS SHELL CC CXX CPP AR RANLIB DOXYGEN SWIG SWIGOPT CCSHARED CXXSHARED PYTHON_INCLUDE CPP_DLLIBS SO

endif  # ifeq ($(ARCH),i686)

